## mingw-w64-seexpr-2.11-4.src.tar.zst

=== CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

## CMake compatibility issues: don't modify this, please!
CMAKE_MINIMUM_REQUIRED( VERSION 2.4.6 )
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
## allow more human readable "if then else" constructs
SET( CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE )
## Use verbose make file
SET ( CMAKE_VERBOSE_MAKEFILE TRUE )



## project name & version
PROJECT( SeExpr )
SET( ${PROJECT_NAME}_MAJOR_VERSION 0 )
SET( ${PROJECT_NAME}_MINOR_VERSION 1 )
SET( ${PROJECT_NAME}_PATCH_LEVEL 0 )

## policies
if(COMMAND cmake_policy)
      cmake_policy(SET CMP0003 NEW)
    endif(COMMAND cmake_policy)

# macros
include(src/build/macros.cmake)

## Setup platform specific helper defines build variants
IF(WIN32)
  include (GenerateExportHeader)
  ADD_DEFINITIONS (-DSEEXPR_WIN32)
ELSE(WIN32)
  ADD_DEFINITIONS (-Wall  -Wextra)
  ADD_DEFINITIONS (-pthread)

  SET( CMAKE_CXX_FLAGS "-fPIC -msse4.1")
ENDIF(WIN32)

## Choose build options
# Disney specific method of choosing variant
IF("$ENV{FLAVOR}" STREQUAL "optimize")
    SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "type of build" FORCE)
ENDIF("$ENV{FLAVOR}" STREQUAL "optimize")
IF("$ENV{FLAVOR}" STREQUAL "debug")
    SET(CMAKE_BUILD_TYPE "Debug" CACHE STRING "type of build" FORCE)
ENDIF("$ENV{FLAVOR}" STREQUAL "debug")
# Set to release if nothing else defined
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF(CMAKE_BUILD_TYPE STREQUAL "Release")
   SET(FLAVORDIR "optimize")
ELSE(CMAKE_BUILD_TYPE STREQUAL "Release")
   SET(FLAVORDIR "debug")
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Release")


## Set install location
IF (NOT DEFINED CMAKE_INSTALL_PREFIX)
   EXECUTE_PROCESS(COMMAND sh -c "echo `uname`-`uname -r | cut -d'-' -f1`-`uname -m`" OUTPUT_VARIABLE VARIANT_DIRECTORY OUTPUT_STRIP_TRAILING_WHITESPACE)
   #EXECUTE_PROCESS(COMMAND uname OUTPUT_VARIABLE VARIANT_DIRECTORY OUTPUT_STRIP_TRAILING_WHITESPACE)
   SET(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/${VARIANT_DIRECTORY}-${FLAVORDIR}")
ENDIF(NOT DEFINED CMAKE_INSTALL_PREFIX)

## Make modules able to see seexpr library
# Setup environment variable to link seexpr
SET( SEEXPR_LIBRARIES SeExpr )
SET( SEEXPR_EDITOR_LIBRARIES SeExprEditor )
# make it so seexpr can be found
INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/src/SeExpr )
INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/src/SeExprEditor )

# The library directory is configured by setting CMAKE_INSTALL_LIBDIR.
# Otherwise, the defaults set here are used.
IF(EXISTS "/usr/lib64" AND NOT IS_SYMLINK "/usr/lib64")
    SET(CMAKE_INSTALL_LIBDIR "lib64" CACHE STRING "Library Directory Basename")
ELSE()
    SET(CMAKE_INSTALL_LIBDIR "lib" CACHE STRING "Library Directory Basename")
ENDIF()

## Traverse subdirectories
ADD_SUBDIRECTORY (src/SeExpr)
ADD_SUBDIRECTORY (src/SeExprEditor)
ADD_SUBDIRECTORY (src/doc)
ADD_SUBDIRECTORY (src/demos)
ADD_SUBDIRECTORY (src/tests)

=== Makefile ===
#!/usr/bin/env make
SH ?= sh
uname_S := $(shell $(SH) -c 'uname -s || echo system')
uname_R := $(shell $(SH) -c 'uname -r | cut -d- -f1 || echo release')
uname_M := $(shell $(SH) -c 'uname -m || echo cpu')
FLAVOR ?= optimize

platformdir ?= $(uname_S)-$(uname_R)-$(uname_M)-$(FLAVOR)
builddir ?= $(CURDIR)/build/$(platformdir)

prefix ?= $(CURDIR)/$(platformdir)
#DESTDIR =

CMAKE_FLAGS ?= -DCMAKE_INSTALL_PREFIX=$(prefix)

# The default target in this Makefile is...
all::

install: all
	$(MAKE) -C $(builddir) DESTDIR=$(DESTDIR) install

$(builddir)/stamp: $(CMAKE_FILES)
	mkdir -p $(builddir)
	cd $(builddir) && cmake $(CMAKE_FLAGS) ../..
	touch $@

all:: $(builddir)/stamp
	$(MAKE) -C $(builddir) $(MAKEARGS) all

clean: $(builddir)/stamp
	$(MAKE) -C $(builddir) $(MAKEARGS) clean

.PHONY: all
.PHONY: clean
.PHONY: install

=== src/SeExpr/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

FILE(GLOB io_cpp "*.cpp")

BuildParserScanner(SeExprParserLex SeExprParser SeExpr parser_cpp)

## Make the SeExpr library
ADD_LIBRARY (SeExpr SHARED ${io_cpp} ${core_cpp} ${parser_cpp})
ADD_LIBRARY (SeExpr-static  ${io_cpp} ${core_cpp} ${parser_cpp})
SET_TARGET_PROPERTIES(SeExpr-static PROPERTIES OUTPUT_NAME "SeExpr")


IF(NOT WIN32)
   TARGET_LINK_LIBRARIES(SeExpr "dl" "pthread")
   TARGET_LINK_LIBRARIES(SeExpr-static "dl" "pthread")
ENDIF(NOT WIN32)
## Install binary and includes
FILE(GLOB public_includes "*.h")
INSTALL (TARGETS SeExpr SeExpr-static DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL (FILES ${public_includes} DESTINATION include)

=== src/SeExprEditor/CMakeLists.txt ===
# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

find_package(PythonInterp)
find_package(PythonLibs)

macro(get_build_info NAME STORAGE)
    execute_process(
        COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/build/build-info ${NAME}
        OUTPUT_VARIABLE ${STORAGE}
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endmacro()

get_build_info(python-site PYTHON_SITE)
get_build_info(python-inc PYTHON_INCLUDE_DIR)
get_build_info(sip-inc SIP_INCLUDE_DIR)
get_build_info(pyqt4-sip PYQT4_SIP)

# Other package dependencies...

find_package(OpenGL)
find_package(Qt4 COMPONENTS QtCore QtGui QtOpenGL)

if(QT4_FOUND)

    BuildParserScanner(SeExprSpecParserLex SeExprSpecParser SeExprEdSpec
                       editor_parser_cpp)

    set(SeExprEd_MOC_HDRS SeExprEdBrowser.h SeExprEdColorCurve.h
        SeExprEdColorSwatchWidget.h SeExprEdControlCollection.h
        SeExprEdControl.h SeExprEdCurve.h SeExprEdDialog.h SeExprEditor.h
        SeExprEdFileDialog.h SeExprEdGrapher2d.h SeExprEdPopupDocumentation.h
        SeExprEdShortEdit.h)

    set(SeExprEd_CPPS SeExprEdFileDialog.cpp SeExprEdControl.cpp
        SeExprEditor.cpp SeExpressionEditor.cpp SeExprEdShortEdit.cpp
        SeExprEdCurve.cpp  SeExprEdColorCurve.cpp SeExprEdColorSwatchWidget.cpp
        SeExprEdEditableExpression.cpp SeExprEdPopupDocumentation.cpp
        SeExprEdCompletionModel.cpp SeExprEdDialog.cpp
        SeExprEdControlCollection.cpp SeExprEdGrapher2d.cpp SeExprEdBrowser.cpp
        SeExprEdExpression.cpp )

    qt4_wrap_cpp(SeExprEd_MOC_SRCS ${SeExprEd_MOC_HDRS})

    add_library(SeExprEditor SHARED ${SeExprEd_CPPS} ${SeExprEd_MOC_SRCS}
                ${editor_parser_cpp})

IF(WIN32)
    add_library(SeExprEditor ${SeExprEd_CPPS} ${SeExprEd_MOC_SRCS}
                ${editor_parser_cpp})
    GENERATE_EXPORT_HEADER(SeExprEditor
                           BASE_NAME SeExprEditor
                           EXPORT_MACRO_NAME SeExprEditor
                           EXPORT_FILE_NAME SeExprEditor_Export.h
                           STATIC_DEFINE SeExprEditor_BUILT_AS_STATIC )
ENDIF(WIN32)

    include_directories(${QT_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(SeExprEditor ${QT_QTCORE_LIBRARY})
    target_link_libraries(SeExprEditor ${QT_QTGUI_LIBRARY})
    target_link_libraries(SeExprEditor ${QT_QTOPENGL_LIBRARY})
    target_link_libraries(SeExprEditor ${GLUT_LIBRARY} ${OPENGL_LIBRARY})

IF(WIN32)
    target_link_libraries(SeExprEditor opengl32)
ENDIF(WIN32)

    target_link_libraries(SeExprEditor ${SEEXPR_LIBRARIES})

    install(TARGETS SeExprEditor DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${SeExprEd_MOC_HDRS}
            DESTINATION include/SeExprEditor)

    # Generate python module expreditor, using sip

    find_program(SIP_EXEC sip)
    set(SIP_QT_TAG -t Qt_4_5_0)  # fix 'sip: QFileIconProvider is undefined'

    set(CMAKE_CXX_FLAGS "-std=c++0x")
    set(CMAKE_INSTALL_PYTHON "${PYTHON_SITE}/SeExpr" )
    include_directories(${SIP_INCLUDE_DIR} ${PYQT4_SIP}
                        ${PYTHON_INCLUDE_DIR} ${QT_HEADERS_DIR}/QtCore
                        ${QT_HEADERS_DIR}/QtGui)

    add_custom_command(OUTPUT sipexpreditorpart0.cpp
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/SeExprEditor.sip
                       COMMENT 'Processing SeExprEditor.sip'
                       COMMAND ${SIP_EXEC} -w -c .
                       -x VendorID -x PyQt_NoPrintRangeBug -x Py_v3
                       ${SIP_QT_TAG}
                       -t WS_X11 -g -j 1
                       -I. -I${PYQT4_SIP} -I${SIP_INCLUDE_DIR}
                       ${CMAKE_CURRENT_SOURCE_DIR}/SeExprEditor.sip
                       VERBATIM)

    add_library(expreditor SHARED sipexpreditorpart0.cpp)
    target_link_libraries(expreditor SeExprEditor ${SEEXPR_LIBRARIES}
                          ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY}
                          ${QT_QTOPENGL_LIBRARY} ${OPENGL_LIBRARY}
                          ${GLUT_LIBRARY} ${PYTHON_LIBRARIES})

    # No prefix on python module name
    set_target_properties(expreditor PROPERTIES PREFIX "")
    install(TARGETS expreditor DESTINATION ${CMAKE_INSTALL_PYTHON})
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py
            DESTINATION ${CMAKE_INSTALL_PYTHON})

endif(QT4_FOUND)

=== src/demos/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

ADD_EXECUTABLE(asciiGraph "asciiGraph.cpp")
target_link_libraries(asciiGraph ${SEEXPR_LIBRARIES})
install(TARGETS asciiGraph DESTINATION bin)

ADD_EXECUTABLE(asciiCalc "asciiCalculator.cpp")
target_link_libraries(asciiCalc ${SEEXPR_LIBRARIES})
install(TARGETS asciiCalc DESTINATION bin)



ADD_SUBDIRECTORY (imageSynth)
ADD_SUBDIRECTORY (imageEditor)
ADD_SUBDIRECTORY (segraph)
ADD_SUBDIRECTORY (rman)

=== src/doc/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

find_package(Doxygen)
IF(DOXYGEN_FOUND AND NOT WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  FILE(GLOB (DOCUMENTED_FILES ../lib/*.h))

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doxygen.txt
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile >doxygen.txt
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)

  add_custom_target(doc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen.txt)

  INSTALL( DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ DESTINATION share/doc/SeExpr )
  INSTALL( FILES userdoc.txt   DESTINATION share/doc/SeExpr/ RENAME SeExpressions.html )
  INSTALL( FILES Se_voronoi_1.png Se_voronoi_2.png Se_voronoi_3.png Se_voronoi_4.png Se_voronoi_5.png DESTINATION share/doc/SeExpr )
  INSTALL( FILES ui_addWidget.png ui_browser.png ui_editor1.png ui_emptyLayout.png ui_final.png ui_preview.png DESTINATION share/doc/SeExpr )

ENDIF(DOXYGEN_FOUND AND NOT WIN32)

=== src/tests/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

foreach(item basic)
    ADD_EXECUTABLE(${item} "${item}.cpp")
    target_link_libraries(${item} ${SEEXPR_LIBRARIES})
    install(TARGETS ${item} DESTINATION share/test/SeExpr)
endforeach(item)

=== src/demos/imageEditor/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

# Set application root dir for use inside the source code.
cmake_policy(SET CMP0005 NEW)
add_definitions(-DIMAGE_EDITOR_ROOT="${CMAKE_INSTALL_PREFIX}")

find_package(Qt4 COMPONENTS QtCore QtGui) # find and setup Qt4 for this project
find_package(PNG)

if(QT4_FOUND AND PNG_FOUND)
    set(imageEditor_MOC_HDRS ImageEditorDialog.h)
    set(imageEditor_CPPS imageEditor.cpp)
    qt4_wrap_cpp(imageEditor_MOC_SRCS ${imageEditor_MOC_HDRS})

    add_executable(imageEditor ${imageEditor_CPPS} ${imageEditor_MOC_SRCS})
    include_directories(${QT_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
    include_directories(${SEEXPR_EDITOR_INCLUDES})
    target_link_libraries(imageEditor ${QT_QTCORE_LIBRARY})
    target_link_libraries(imageEditor ${QT_QTGUI_LIBRARY})
    target_link_libraries(imageEditor ${SEEXPR_LIBRARIES})
    target_link_libraries(imageEditor ${SEEXPR_EDITOR_LIBRARIES})

    INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
    TARGET_LINK_LIBRARIES(imageEditor ${PNG_LIBRARIES})
    install(TARGETS imageEditor DESTINATION bin)

endif(QT4_FOUND AND PNG_FOUND)


INSTALL( FILES fbm.se noisecolor1.se noisecolor2.se noise.se raytrace.se sinc.se
         DESTINATION share/SeExpr/expressions/ )

=== src/demos/imageSynth/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

FIND_PACKAGE(PNG)
IF(PNG_FOUND)
    INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
    ADD_EXECUTABLE(imageSynth "imageSynth.cpp")
    TARGET_LINK_LIBRARIES(imageSynth ${PNG_LIBRARIES} ${SEEXPR_LIBRARIES})
    install(TARGETS imageSynth DESTINATION bin)
ENDIF(PNG_FOUND)

=== src/demos/rman/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

# Non optimal, can't figure out better way right now
SET(RMANTREE_TEST $ENV{RMANTREE} CACHE STRING stuff FORCE)
STRING(COMPARE EQUAL "${RMANTREE_TEST}" "" RMAN_SET)

IF(NOT ${RMAN_SET})
include_directories($ENV{RMANTREE}/include)
link_directories($ENV{RMANTREE}/lib)
add_library(SeExprOp MODULE seop.cpp)
target_link_libraries(SeExprOp prman ${SEEXPR_LIBRARIES})
FILE(GLOB ribs "*.rib")
install (TARGETS SeExprOp DESTINATION ${CMAKE_INSTALL_LIBDIR}/prman)

foreach (SHADERSOURCE testdisp testse)
    ADD_CUSTOM_COMMAND(
      SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/${SHADERSOURCE}.sl
      COMMAND "shader"
      ARGS -o ${CMAKE_CURRENT_BINARY_DIR}/${SHADERSOURCE}.slo ${CMAKE_CURRENT_SOURCE_DIR}/${SHADERSOURCE}.sl 
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${SHADERSOURCE}.slo
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${SHADERSOURCE}.sl SeExprOp
    )
    add_custom_target(shader-${SHADERSOURCE} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SHADERSOURCE}.slo)
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${SHADERSOURCE}.slo DESTINATION ${CMAKE_INSTALL_LIBDIR}/prman)
endforeach(SHADERSOURCE)
install (FILES ${ribs} DESTINATION ${CMAKE_INSTALL_LIBDIR}/prman)
endif(NOT ${RMAN_SET})

=== src/demos/segraph/CMakeLists.txt ===

# Copyright Disney Enterprises, Inc.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License
# and the following modification to it: Section 6 Trademarks.
# deleted and replaced with:
#
# 6. Trademarks. This License does not grant permission to use the
# trade names, trademarks, service marks, or product names of the
# Licensor and its affiliates, except as required for reproducing
# the content of the NOTICE file.
#
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0

find_package(Qt4 COMPONENTS QtCore QtGui) # find and setup Qt4 for this project
if(QT4_FOUND)
    set(segraph_MOC_HDRS Graph.h GraphWindow.h)
    set(segraph_CPPS segraph.cpp Graph.cpp GraphWindow.cpp)
    qt4_wrap_cpp(segraph_MOC_SRCS ${segraph_MOC_HDRS})
    
    add_executable(segraph ${segraph_CPPS} ${segraph_MOC_SRCS})
    install(TARGETS segraph DESTINATION share/SeExpr/demo)
    include_directories(${QT_INCLUDE_DIR})
    include_directories(${SEEXPR_EDITOR_INCLUDES})
    target_link_libraries(segraph ${QT_QTCORE_LIBRARY})
    target_link_libraries(segraph ${QT_QTGUI_LIBRARY})
    target_link_libraries(segraph ${SEEXPR_LIBRARIES})
    target_link_libraries(segraph ${SEEXPR_EDITOR_LIBRARIES})
endif(QT4_FOUND)

=== PKGBUILD ===
# Maintainer: Andrew Sun <adsun701@gmail.com>

_realname=seexpr
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.11
pkgrel=4
pkgdesc="A simple expression language (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://hoene.github.io/seexpr/"
msys2_repository_url="https://github.com/wdas/SeExpr"
license=("spdx:Apache-2.0")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
source=("https://github.com/wdas/SeExpr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-seexpr-2.11-fix-cxxflags.patch"
        "0002-seexpr-2.11-fix-inline-error.patch"
        "0003-seexpr-2.11-fix-dll-installation.patch")
sha256sums=('bf4a498f86aa3fc19aad3d7384de11d5df76f7f71587c9bd789f5e50f8090e1a'
            '1eeaba08b574ca1c6ff5ce4ddcc45319dbdb3d4d9f82ca6ba9a9af32a0dbc183'
            'f7733debf6a8d0ef169abfd11eb18434a57b7e2608e49aca8131bd0f264f330f'
            'caa6576737ee72bb3961d299b7479a4a6629a90e5dde0e220ba57cef62624242')

prepare() {
  cd "${srcdir}/SeExpr-${pkgver}"
  patch -p1 -i "${srcdir}/0001-seexpr-2.11-fix-cxxflags.patch"
  patch -p1 -i "${srcdir}/0002-seexpr-2.11-fix-inline-error.patch"
  patch -p1 -i "${srcdir}/0003-seexpr-2.11-fix-dll-installation.patch"
  
  # Don't build the demo even if QT4 is found
  # sed -i 's/if(QT4_FOUND)/if(FALSE)/' "${srcdir}/SeExpr-${pkgver}/src/demos/segraph/CMakeLists.txt"

  # Don't build doc, demos and tests as they are not needed
  sed -i 's/ADD_SUBDIRECTORY (src\/doc)/ /' "${srcdir}/SeExpr-${pkgver}/CMakeLists.txt"
  sed -i 's/ADD_SUBDIRECTORY (src\/demos)/ /' "${srcdir}/SeExpr-${pkgver}/CMakeLists.txt"
  sed -i 's/ADD_SUBDIRECTORY (src\/tests)/ /' "${srcdir}/SeExpr-${pkgver}/CMakeLists.txt"
}

build() {
  # Shared Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
  -G"MSYS Makefiles" \
  -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
  -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
  -DCMAKE_BUILD_TYPE=Release \
  -DBUILD_SHARED_LIBS:BOOL='ON' \
  -DBUILD_TESTS:BOOL='OFF' \
  -DCMAKE_COLOR_MAKEFILE:BOOL='ON' \
  -Wno-dev \
  ../SeExpr-${pkgver}
  
  cmake --build .
  
  # Static Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
  -G"MSYS Makefiles" \
  -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
  -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
  -DCMAKE_BUILD_TYPE=Release \
  -DBUILD_SHARED_LIBS:BOOL='OFF' \
  -DBUILD_TESTS:BOOL='OFF' \
  -DCMAKE_COLOR_MAKEFILE:BOOL='ON' \
  -Wno-dev \
  ../SeExpr-${pkgver}
  
  cmake --build .
}

package() {
  # Static Install
  DESTDIR="${pkgdir}" cmake --install build-${MSYSTEM}-static

  # Shared Install
  DESTDIR="${pkgdir}" cmake --install build-${MSYSTEM}-shared

  install -Dm644 "${srcdir}"/SeExpr-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
